//+------------------------------------------------------------------+
//|                                       TickIchimoku_v1.2 600+.mq4 |
//|                                Copyright  2014, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"


#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 MediumSeaGreen
#property indicator_color4 Aquamarine
#property indicator_color5 Coral
#property indicator_color6 CLR_NONE
#property indicator_color7 CLR_NONE
#property indicator_style4 2
#property indicator_style5 2

//---- input parameters
extern string  UniqueName        = "TickIchimoku";   
extern int     Tenkan            =          9; // Tenkan period 
extern int     Kijun             =         26; // Kijun period
extern int     Senkou            =         52; // Senkou period
extern int     TicksNumber       =         15; // TimeFrame in ticks
extern int     SecsNumber        =          0; // TimeFrame in secs
extern int     BarsNumber        =        500; // Number of bars   
extern color   colorCloudUp      = Aquamarine;
extern color   colorCloudDn      =      Coral;
extern int     cloudStyle        =  STYLE_DOT;
extern color   colorBarDn        =        Red;
extern color   colorBarUp        =      Green;
extern color   colorBarNeutral   =    DimGray;
extern int     widthWick         =          1;
extern int     widthBody         =          5;

//---- buffers 
double tenkan[];
double kijun[];
double spanA2[];
double spanB2[];
double chinkou[];
double minValue[];
double maxValue[];

double Hi[], Lo[], tOpen[], tClose[];
 
int      window, tickCounter=0, barCounter, pSecs, nextSecs;
datetime pTime;
string   short_name, t;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   SetIndexBuffer(0,  tenkan); SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(1,   kijun); SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(2, chinkou); SetIndexStyle(2, DRAW_LINE); SetIndexShift(2,-Kijun);
   SetIndexBuffer(3,  spanA2); SetIndexStyle(3, DRAW_LINE); SetIndexShift(3, Kijun); 
   SetIndexBuffer(4,  spanB2); SetIndexStyle(4, DRAW_LINE); SetIndexShift(4, Kijun); 
   SetIndexBuffer(5,maxValue); SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5, 158);
   SetIndexBuffer(6,minValue); SetIndexStyle(6,DRAW_ARROW); SetIndexArrow(6, 158);
   
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   
   if(TicksNumber > 0) t = TicksNumber +" Ticks] ";
   if(SecsNumber  > 0) t = SecsNumber  +" Secs] ";
   
   short_name="TickIchimoku_v1.2 600+["+t+"("+Tenkan+","+Kijun+","+Senkou+")";
   IndicatorShortName(short_name);
   
   SetIndexLabel(0,"Tenkan Sen");
   SetIndexLabel(1,"Kijun Sen");
   SetIndexLabel(2,"Chinkou Span");
   SetIndexLabel(3,"Senkou Span A");
   SetIndexLabel(4,"Senkou Span B");
   
   SetIndexLabel(5,NULL);
   SetIndexLabel(6,NULL);
   
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
   SetIndexEmptyValue(5,0.0);
   SetIndexEmptyValue(6,0.0);
   
   if(SecsNumber > 0) nextSecs = TimeCurrent() - MathMod(TimeCurrent(),SecsNumber) + SecsNumber;  
   
   pTime = Time[0];
   //pSecs = TimeCurrent(); 
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   deleteObj(UniqueName);
   
   return(0);
}



//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int i,cnt_bars = IndicatorCounted();
   
   window = WindowFind(short_name);
   
   if(cnt_bars < 0) return(0);
   if(cnt_bars < 1) 
   {
      for(i=Bars-1;i>=0;i--)
      {
      tenkan[i]   = 0.0;
      kijun[i]    = 0.0;
      spanA2[i]   = 0.0;
      spanB2[i]   = 0.0;
      chinkou[i]  = 0.0;
      maxValue[i] = 0.0;
      minValue[i] = 0.0;
      }
   }
   
   if (ArraySize(Hi) != Bars) 
   {
   ArraySetAsSeries(Hi, false); ArraySetAsSeries(Lo, false); ArraySetAsSeries(tOpen, false); ArraySetAsSeries(tClose, false); 
   ArrayResize(Hi, Bars); ArrayResize(Lo, Bars); ArrayResize(tOpen, Bars); ArrayResize(tClose, Bars);
   ArraySetAsSeries(Hi, true); ArraySetAsSeries(Lo, true); ArraySetAsSeries(tOpen, true); ArraySetAsSeries(tClose, true);
   }
   
   
   
   tickCounter++;
   
   bool tcond = false;   
   if(TicksNumber > 0 && SecsNumber == 0) tcond = tickCounter > 0 && tickCounter % TicksNumber == 0;
   if(TicksNumber == 0 && SecsNumber > 0) tcond = TimeCurrent() >= nextSecs;
   
   if(tcond) 
   {
   barCounter ++; 
   if(barCounter > BarsNumber) barCounter = BarsNumber;
   if(!isNewBar()) ShiftArray(0); 
   tOpen[0]  = Bid;
   tClose[0] = Bid;
   Hi[0]     = Bid;
   Lo[0]     = Bid; 
   if(SecsNumber > 0) nextSecs = TimeCurrent() - MathMod(TimeCurrent(),SecsNumber) + SecsNumber;  //pSecs = TimeCurrent();
   }
   
   if(barCounter > 0)
   {
   if(isNewBar()) ShiftArray(1);
   tClose[0] = Bid;
   Hi[0] = MathMax(Hi[0],Bid);
   if(Lo[0] > 0) Lo[0] = MathMin(Lo[0],Bid); else Lo[0] = Bid; 
   
   drawCandle(Time[0],Hi[0],Lo[0],tOpen[0],tClose[0]);
   }
      
   double gap = ((Hi[1] - Lo[1]) + (Hi[2] - Lo[2]) + (Hi[3] - Lo[3]) + (Hi[4] - Lo[4])+ (Hi[5] - Lo[5]))/5;
   
   maxValue[0] = Hi[0] + 0.2*gap;
   minValue[0] = Lo[0] - 0.3*gap;
   
   
   
   if(barCounter >= BarsNumber) 
   {
      for(i=BarsNumber; i < BarsNumber+1;i++)
      { 
      tenkan[i]   = 0.0;
      kijun[i]    = 0.0;
      spanA2[i]   = 0.0;
      spanB2[i]   = 0.0;
      chinkou[i]  = 0.0;
      maxValue[i] = 0.0;
      minValue[i] = 0.0;
      }
   deleteObj(UniqueName+": "+TimeToStr(Time[BarsNumber]));
   }
     
   chinkou[0] = tClose[0]; 
      
   double tenkanHi = TickHighest(Tenkan); 
   double tenkanLo = TickLowest (Tenkan); 
   
   if(barCounter > Tenkan) tenkan[0] = 0.5*(tenkanHi + tenkanLo);
   
   double kijunHi = TickHighest(Kijun); 
   double kijunLo = TickLowest (Kijun); 
   
   if(barCounter > Kijun) 
   {
   kijun[0] = 0.5*(kijunHi + kijunLo);
   spanA2[0] = (tenkan[0] + kijun[0])/2;
   }
   
   double senkouHi = TickHighest(Senkou); 
   double senkouLo = TickLowest (Senkou); 
   
   if(barCounter > Senkou) 
   {
   spanB2[0] = (senkouHi + senkouLo)/2;
   if(spanB2[0] > 0) plotHisto(Time[0] + Kijun*Period()*60,spanA2[0],spanB2[0]);
   }
//----
   return(0);
}
//+------------------------------------------------------------------+
double TickLowest(int per)
{
   double lowest = 1000000;
   for(int i = 0;i < per;i++) lowest = MathMin(lowest,Lo[i]);
   return(lowest);
}                

double TickHighest(int per)
{
   double highest = 0;
   for(int i = 0;i < per;i++) highest = MathMax(highest,Hi[i]);
   return(highest);
} 

void drawCandle(int time, double high, double low, double open, double close)
{
   if(open > close) {color bodyColor = colorBarDn; color wickColor = colorBarDn;}   
   else
   if(open < close) {bodyColor = colorBarUp; wickColor = colorBarUp;}
   else {bodyColor = colorBarNeutral; wickColor = colorBarNeutral;}   
   
   string  Name = UniqueName+": "+TimeToStr(time);//+":"+secs;//;addZero(,2);
   string oName = Name +" wick";
   if (ObjectFind(oName) < 0) ObjectCreate(oName,OBJ_TREND,window,time,0,time,0);
   ObjectSet(oName, OBJPROP_PRICE1,high);
   ObjectSet(oName, OBJPROP_PRICE2,low);
   ObjectSet(oName, OBJPROP_COLOR, wickColor);
   ObjectSet(oName, OBJPROP_WIDTH, widthWick);
   ObjectSet(oName, OBJPROP_RAY, false);
   ObjectSet(oName, OBJPROP_BACK, true);
           
   oName = Name +" body";
   if (ObjectFind(oName) < 0) ObjectCreate(oName,OBJ_TREND,window,time,0,time,0);
   ObjectSet(oName, OBJPROP_PRICE1,open);
   ObjectSet(oName, OBJPROP_PRICE2,close);
   ObjectSet(oName, OBJPROP_COLOR, bodyColor);
   ObjectSet(oName, OBJPROP_WIDTH, widthBody);
   ObjectSet(oName, OBJPROP_RAY, false);
   ObjectSet(oName, OBJPROP_BACK, true);
  
}

void ShiftArray(int mode)
{
   if(mode==0)
   {
      for(int cnt=barCounter; cnt >= 0; cnt--)
      {
      Hi [cnt]      = Hi[cnt-1];
      Lo [cnt]      = Lo[cnt-1];
      tOpen[cnt]    = tOpen[cnt-1];
      tClose[cnt]   = tClose[cnt-1];
      tenkan[cnt]   = tenkan[cnt-1];
      kijun[cnt]    = kijun[cnt-1];
      spanA2[cnt]   = spanA2[cnt-1];
      spanB2[cnt]   = spanB2[cnt-1];
      chinkou[cnt]  = chinkou[cnt-1];
      maxValue[cnt] = maxValue[cnt-1];
      minValue[cnt] = minValue[cnt-1];
      
      drawCandle(Time[cnt],Hi[cnt],Lo[cnt],tOpen[cnt],tClose[cnt]);
         
         if(barCounter > Senkou && spanB2[cnt-1] > 0) 
         {
         int shift = iBarShift(NULL,0,Time[cnt]) - Kijun;
         if(shift < 0) plotHisto(Time[cnt] + Kijun*Period()*60,spanA2[cnt],spanB2[cnt]);
         else plotHisto(Time[shift],spanA2[cnt],spanB2[cnt]);
         }
      }
   }
   else
   {
      for(cnt=1; cnt <= barCounter; cnt++)
      {
      Hi [cnt-1]      = Hi[cnt];
      Lo [cnt-1]      = Lo[cnt];
      tOpen[cnt-1]    = tOpen[cnt];
      tClose[cnt-1]   = tClose[cnt];
      tenkan[cnt-1]   = tenkan[cnt];
      kijun[cnt-1]    = kijun[cnt];
      spanA2[cnt-1]   = spanA2[cnt];
      spanB2[cnt-1]   = spanB2[cnt];
      chinkou[cnt-1]  = chinkou[cnt];
      maxValue[cnt-1] = maxValue[cnt];
      minValue[cnt-1] = minValue[cnt];
      
      drawCandle(Time[cnt-1],Hi[cnt-1],Lo[cnt-1],tOpen[cnt-1],tClose[cnt-1]);
         
         if(barCounter > Senkou && spanB2[cnt-1] > 0)
         { 
         shift = iBarShift(NULL,0,Time[cnt-1]) - Kijun;
         if(shift < 0) plotHisto(Time[cnt-1] + Kijun*Period()*60,spanA2[cnt-1],spanB2[cnt-1]);
         else plotHisto(Time[shift],spanA2[cnt-1],spanB2[cnt-1]);
         }
      Hi[cnt]       = 0.0;
      Lo[cnt]       = 0.0;
      tOpen[cnt]    = 0.0;
      tClose[cnt]   = 0.0;
      tenkan[cnt]   = 0.0;
      kijun[cnt]    = 0.0;
      spanA2[cnt]   = 0.0;
      spanB2[cnt]   = 0.0;
      chinkou[cnt]  = 0.0;
      maxValue[cnt] = 0;
      minValue[cnt] = 0;
      
      deleteObj(UniqueName+": "+TimeToStr(Time[cnt]));
      }
   }
}

bool isNewBar()
{
   bool result = false;
   if (Time[0] != pTime)
   {
   result = true;
   pTime = Time[0];
   }   

   return(result);
}



bool deleteObj(string name)
{
   bool result = false;
   
   int length = StringLen(name);
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
   string objName = ObjectName(i); 
   if(StringSubstr(objName,0,length) == name) {ObjectDelete(objName); result = true;}
   }
   
   return(result);
}
               
void plotHisto(int time,double price1, double price2)
{

string  Name = UniqueName+": "+TimeToStr(time)+" span";
   
if(price1 > price2) color cloudColor = colorCloudUp; else cloudColor = colorCloudDn;  
   
   if(ObjectFind(Name) < 0) ObjectCreate(Name,OBJ_TREND,window,time,0,time,0);
   ObjectSet(Name, OBJPROP_PRICE1,price1);
   ObjectSet(Name, OBJPROP_PRICE2,price2);
   ObjectSet(Name, OBJPROP_COLOR, cloudColor);
   ObjectSet(Name, OBJPROP_STYLE, cloudStyle);
   ObjectSet(Name, OBJPROP_WIDTH, 1);
   ObjectSet(Name, OBJPROP_RAY, false);
   ObjectSet(Name, OBJPROP_BACK, true);
}
/*
string addZero(int value, int digits) 
{
   for (string result = DoubleToStr(value, 0); StringLen(result) < digits; result = "0" + result) {}
   return (result);
}
*/            